# List All Transactions Source: https://docs.procuros.io/en/api/v2/all-transactions/list-all-transactions /en/api/v2/openapi-v2.yaml get /v2/all-transactions List all existing transactions to and from your trade partners. # Show Transaction Source: https://docs.procuros.io/en/api/v2/all-transactions/show-transaction /en/api/v2/openapi-v2.yaml get /v2/all-transactions/{procurosTransactionId} Show a single transaction. # Basics Source: https://docs.procuros.io/en/api/v2/api-concepts ## API Versioning We are constantly improving and expanding our API. In order to give you the choice of when (or if) you want to benefit from these changes, we are versioning our API. Our API follows standard [semantic versioning](https://semver.org/), which means we will introduce a new major version number in case new, backwards-incompatible changes are introduced to the Procuros API. The API version is included in the path of every endpoint. Example: `https://api.procuros.io/v2/transactions` (`v2` shows this endpoint uses version 2) Keep in mind, that purely additive changes are not considered backwards-incompatible, which means your system needs to be able to handle new properties added to the JSON data returned by our API. Use the version selector in the top lefthand corner of this page to adjust the API documentation to an older version. ## Date and Time For datetime attributes, we are using the ISO8601 format. However, we recommend sending datetime attributes using the `Europe/Berlin` timezone. Furthermore, **all** datetime attributes returned by our API will be in `Europe/Berlin` timezone, regardless of what timezone was used when storing the record. ## Testing You can use our **Staging environment** to test your interaction with the Procuros API, which protects you from accidentally sending transactions to your Trade Partners. Our Staging and Production environments can easily be distinguished by the domain. * Staging: `https://api.procuros-staging.io/v2` * Production: `https://api.procuros.io/v2` # Authentication Source: https://docs.procuros.io/en/api/v2/concept-authentication The Procuros API uses API tokens to authenticate requests. Please contact `[email protected]` to request an API token. In order to perform an authenticated request, use the `Authorization` header to provide your API token as a "bearer token" like this: `Authorization: Bearer `. All requests to all endpoints of our API have to be made using the above authentication method. Unauthenticated calls will fail with a `401` status code. ## Testing your Connection Below are examples of how to ping the API to ensure your credentials are correct. If you get a successful response from the enpoint, your authorization is confirmed. If you receive a `401 Unauthorized` error then your API key is not correct for this environment. ```bash bash theme={null} curl --request GET \ --url 'https://api.procuros.io/v2/ping' \ --header 'Accept: application/json' \ --header 'Authorization: Bearer ' ``` ```php php theme={null} $client = new \GuzzleHttp\Client(); $client->request('POST', 'https://api.procuros.io/v2/ping', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ' ] ]); $response->getStatusCode(); // => 200 ``` ## SSL Encryption Requests to the Procuros API can only be made over HTTPS. Unsecured requests using HTTP will fail. # Error Handling Source: https://docs.procuros.io/en/api/v2/concept-error-handling Standard HTTP response status codes are used to indicate the success or failure of a request made to the Procuros API. Status codes in the `2XX` range indicate success, codes in the `4XX` and `5XX` range indicate failure. HTTP status codes that can be returned by the Procuros API: | HTTP Status Code | Meaning | | - | - | | **400** - Bad Request | There was an issue with the request sent, such as a duplicate payload was sent. | | **401** - Unauthorized | The API token is missing or invalid. | | **403** - Forbidden | The API token doesn't have permission to perform this action. | | **404** - Not Found | The requested entity (e.g. Transaction) could not be found. | | **422** - Validation Failed | The request data is invalid. Responses contain `errors` that show what field failed validation and why. | | **429** - Too Many Requests | You are calling the API too much. Check if you can use our bulk endpoints, otherwise contact support to get your rate limit increased. (won't happen to >99% of customers) | | **500**, **502**, **503**, **504** - Server Error | An error occurred on Procuros side (rare cases) | ## Error Responses To help you troubleshoot your interactions with the Procuros API, we've included further information within the responses returned from failed requests to the API. | Property | Type | Description | | - | - | - | | `message` | string | Short error descriptions | | `errors` | object | (Only on 422 "Validation Failed" Errors) Map of fields that failed validation including the corresponding validation error | ### Message `4xx` range responses will always include the `message` property. For example in the case of a `400`, the `message` property will give you the reason why in English. ```json json theme={null} { "message": "Payload already received" } ``` ### Errors For "Validation Failed" Client Errors (HTTP status code `422`), responses include an additional property `errors`, which list all request fields that failed validation and why. Example: ```json json theme={null} { "message": "Invalid data provided.", "errors": { "type": [ "The selected type is invalid." ] } } ``` ### Handling an Error ```php php theme={null} $client = new \GuzzleHttp\Client(); $response = $client->request(...); $statusCode = $response->getStatusCode(); if ($statusCode < 200 || $statusCode > 299) { // handle error // you likely want to check for the exact error codes } ``` ### Example ```php php theme={null} $headers = [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ]; $transaction = [...]; // A transaction payload $client = new \GuzzleHttp\Client(); $client->request('POST', 'https://api.procuros.io/v2/transactions', [ 'headers' => $headers, 'json' => $transaction, ]); $statusCode = $response->getStatusCode(); if ($statusCode < 200 || $statusCode > 299) { if ($statusCode === 400) { \Sentry\captureMessage('BadPayloadSent', $transaction); } if ($statusCode === 422) { \Sentry\captureMessage('ValidationError', $transaction); } if ($statusCode === 500) { markDocumentForLaterRetry($transaction); } \Sentry\captureMessage('UnknownApiError', $transaction); } markDocumentAsProcessed($statusCode, $transaction); ``` ### Error Handling Best Practises The most common errors are related to missing or misconfigured data. Here is an example on how to handle these with the [Report Outgoing Error Request](/en/api/v2/outgoing-transactions/report-outgoing-error) endpoint. ```php php theme={null} $client = new \GuzzleHttp\Client(); $client->request('POST', 'https://api.procuros.io/v2/errors', [ 'headers' => $headers, 'json' => [ 'errorReason' => 'Data XYZ could not be found.', 'errorType' => 'INTERNAL', 'errorContext' => [ 'meta' => 'value' ], 'transactionIdentifier' => 'bestellung-20231203-001', 'transactionType' => 'ORDER', ], ]); ``` #### Best Practise: Missing GTIN * Set `errorType` to: `DATA`. * Set the `errorReason` to: `The GTIN/EAN :gtin couldn't be found` and set up the gtin variable accordingly # Pagination Source: https://docs.procuros.io/en/api/v2/concept-pagination For some of our resources (eg. transactions), a "list" endpoint exists to fetch resources in bulk. These endpoints use a "cursor-based pagination", which means you can use the `per_page` and `cursor` query parameters to step through large collections page by page. ### Requests Requests to paginated "list" endpoints accept the following query parameters: | Parameter | Type | Description | | - | - | - | | `cursor` | String (optional) | Cursor pointing to the beginning of a page | | `per_page` | Integer (optional) | Amount of resources that should be returned. (1-100. Default: 25) | ### Responses All requests to those paginated "list" endpoints have the following response properties: | Property | Type | Description | | - | - | - | | `items` | Array | Array containing the listed resources (eg. transactions) | | `hasMore` | Boolean | Whether or not there are more resources to be fetched after this page | | `perPage` | Integer | Amount of resources returned per page | | `count` | Integer | Amount of resources on the current page | | `nextCursor` | String \| Null | Cursor pointing to the beginning of the next page (Use the `cursor` query parameter value to get the next page of resources) | | `nextPageUrl` | String \| Null | URL pointing to the next page of resources (prebuilt for your convenience) | **Example Response:** ```json json theme={null} { "items": [ {...}, {...} ], "hasMore": true, "perPage": 50, "count": 50, "nextCursor": "kdfhh87sdkfjslasdf7hsbadf", "nextPageUrl": "https://api.procuros.io/v2/transactions?cursor=kdfhh87sdkfjslasdf7hsbadf" } ``` ### Workflow 1. Make a request to the "list" endpoint without the `cursor` query parameter to fetch the first page of resources. Optionally use the `per_page` query parameter to limit the number of resources to fetch. Example: `GET https://api.procuros.io/v2/transactions` 2. From the response, read the `hasMore` property to determine if there are more resources to fetch on subsequent pages. 3. If more resources are available, use the `nextCursor` property on the response to build the URL of your next request. Alternatively, use the `nextPageUrl` that we've prebuilt for you. Example: `GET https://api.procuros.io/v2/transactions?cursor=kdfhh87sdkfjslasdf7hsbadf` 4. Continue with step 2. # Bulk Mark Transactions Processed Source: https://docs.procuros.io/en/api/v2/incoming-transactions/bulk-mark-transactions-processed /en/api/v2/openapi-v2.yaml post /v2/transactions/bulk/mark-processed Mark a list of incoming transactions as processed in a single request. For each item, set `success` to `true` once the transaction has been processed, or `false` if processing failed (optionally with an `errorReason`, `errorType`, and `errorContext`). Transactions previously reported as failed can be recovered by including them again with `success: true` once the issue has been resolved on your side. They move to the delivered state and their associated errors are resolved automatically. # List Incoming Transactions Source: https://docs.procuros.io/en/api/v2/incoming-transactions/list-incoming-transactions /en/api/v2/openapi-v2.yaml get /v2/transactions List unprocessed incoming transactions from your trade partners. # Mark Transaction Processed Source: https://docs.procuros.io/en/api/v2/incoming-transactions/mark-transaction-processed /en/api/v2/openapi-v2.yaml put /v2/transactions/{procurosTransactionId} Report whether your system processed an incoming transaction. Set `success` to `true` once the transaction has been processed, or `false` if processing failed (optionally with an `errorReason`, `errorType`, and `errorContext`). If a transaction was previously reported as failed, you can recover it by calling this endpoint again with `success: true` once the issue has been resolved on your side (for example, after correcting missing master data in your system). The payload is reused from your system, so there is no need to fetch the transaction again: it moves to the delivered state and its associated error is resolved automatically. # Test connection to API Source: https://docs.procuros.io/en/api/v2/misc/test-connection-to-api /en/api/v2/openapi-v2.yaml get /v2/ping Send an authorized request to the API to test the connectivity. # Report Outgoing Error Source: https://docs.procuros.io/en/api/v2/outgoing-transactions/report-outgoing-error /en/api/v2/openapi-v2.yaml post /v2/errors If you encounter an error while building an outgoing transaction payload, you can report it here. The error will enter the same exception handling process as an error reported while processing incoming transactions. # Send Transaction Source: https://docs.procuros.io/en/api/v2/outgoing-transactions/send-transaction /en/api/v2/openapi-v2.yaml post /v2/transactions Create and send a new transaction to one of your trade partners. # Overview Source: https://docs.procuros.io/en/api/v2/overview Welcome to the Procuros API. You are currently reading the documentation for API V2. The Procuros API is the recommended way of integrating with the Procuros Network in order to exchange business transactions with your Trade Partners. Our API follows RESTful patterns, accepts and returns JSON-encoded data and uses standard HTTP verbs and response codes. ## OpenAPI Specification The complete OpenAPI specification for the Procuros API v2 is available in raw format for easy integration with your development tools: Access the complete OpenAPI specification file to use with tools like Postman, Insomnia, or other API development tools. ## Incoming Transactions Incoming Transaction Flow ### Retrieving and Processing Transactions To retrieve unprocessed incoming transactions from Procuros, we recommend using a cron job/interval for simplicity. Looping through the list of retrieved transactions, you will try to process/import them. See our [Quick Start Guide](/en/api/v2/quick-start) for an example how this can be done. ### Reporting Processing Status Once you have looped through the unprocessed transactions and attempted to process them you will report back whether processing was successful or not. If a transaction could not be processed, you will send across an error reason and level. This will trigger the exception handling flow: * An e-mail notification will be sent to the responsible party for resolution * The error will show up in the Procuros Portal together with the error reason for self-service resolution by the responsible party. ## Outgoing Transactions Outgoing Transaction Flow ### Retrieving and Preparing Documents To retrieve new unprocessed documents from the ERP system that should be sent via Procuros we recommend using a cron job/interval that runs every 10-30 minutes for simplicity reasons, but you are free to make this event-based as well. To know which documents should be sent via Procuros, a list of “enabled” customers and suppliers needs to be maintained. This is explained in detail on [Enabled Trade Partners](/en/api/v2/features-enabled-trade-partners). Generally, all outgoing documents for an “enabled” Trade Partner (shipping notices, invoices, etc. for customers and orders for suppliers) should be sent via Procuros. We will handle routing and inactive trade relationships. More on that later. For every document that fulfils the above criteria, you will build the “transaction payload” according to the [API specification](/en/api/v2/incoming-transactions/list-incoming-transactions)) corresponding to the document type (order, shipping notice, etc.). ### Sending Transactions If you are able to successfully build and send a transaction payload to Procuros, we will respond in one of three ways: 1. For documents Procuros intends to forward to the receiving trade partner, the Procuros API responds with an `201: Created` status code and you should mark the document as `TRANSMITTED`. 2. If we determine the transaction should **not** be forwarded to the trade partner (eg. because the trade relationship is not yet active or documents of that type are not currently accepted by the receiving trade partner), the Procuros API will respond with an `202: Accepted` status code and you will mark the document as `NO_ACTION` to indicate to users that the document was accepted by Procuros but will not be forwarded. More on this in [Tracking Document Status](/en/api/v2/features-tracking-document-status). 3. If the transaction payload sent by you contains errors, the Procuros API will respond with a `422: Validation Error`. More on this below. 4. If a different error occurs, such as `PayloadAlreadyReceived` then this will be reported back via the status code `400: Bad Request`. ### Handling Errors If you were not able to successfully build the transaction payload to be sent via Procuros you will send an error payload instead to trigger the Exception Handling flow and allow the responsible parties to fix the underlying issue (i.e. change or add information in the unprocessed document). Error reasons could be e.g. missing GLNs or GTIN/EAN codes. When you send an error payload to the Procuros API, we will respond with an **Error Url** that points to the error within the Procuros Portal. You can attach the Link to the document for which you were unable to build the transaction payload giving your user an easy way to resolve the error fast. You will also receive an Error Url in case the transaction payload you sent is invalid and the Procuros API responds with `422: Validation Error`. In any case, you will re-try sending the document until it succeeds. ## Transport Labels Transport units on Shipping Notice and Dispatch Instruction Response transactions can carry a Procuros-generated SSCC transport label. It is returned as a `transportLabel` object with a `zplUrl` and a `pdfUrl`, giving you the raw ZPL and the rendered PDF version of the same label. To download the file content, call the [Download Transport Label](/en/api/v2/all-transactions/download-transport-label) endpoint using the value of either URL as the `transportLabelUrl` path parameter. The endpoint requires the same API token as the other endpoints and streams the file content back for download. # Quick Start Source: https://docs.procuros.io/en/api/v2/quick-start In this guide, we will go through the process of setting up an API connection, and a few basic endpoints that you can use for EDI document management. We will use PHP as the example language but you can translate the examples to any programming language you desire. ## Connecting to the API We assume for this PHP example that `Guzzle` is installed and available to the script. ```php php theme={null} $client = new \GuzzleHttp\Client(); $response = $client->request('GET', '', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` ## Listing Documents Following on from this, you can use the connection to list orders from your trade partners. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => $headers, ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` All types of documents are returned from this API call. In order to filter for a specific type, you may pass the `filter` URL parameter. For example: ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=ORDER', [ 'headers' => $headers, ]); ``` For a list of all available parameters, please see the [List Incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) API reference. ## Sending Documents Similar to listing documents, you can use the connection to send documents to your trade partners. ```php php theme={null} $transaction = [ "type": "ORDER", "content": [ "header": [ "orderIdentifier": "bestellung-20231203-001", "orderDate": "2023-12-03", "currency": "EUR", "requestedDeliveryDate": "2023-12-06", "buyer": ["identifiers": [["domain": "GS1", "identifier": "3220010000001" ]]], "supplier": ["identifiers": [["domain": "GS1", "identifier": "3220010000013" ]]], "billTo": ["identifiers": [["domain": "GS1", "identifier": "3220010000001" ]]], "shipTo": ["identifiers": [["domain": "GS1", "identifier": "3220010000003" ]]], ], "items": [ [ "identifiers": [["domain": "GS1", "identifier": "2330000000007" ]], "lineNumber": 1, "quantity": 10, "isDepositItem": false, "unitOfMeasure": "EA", "description": "A description of the item", "requestedDeliveryDate": null, "unitPrice": 1.23 ] ] ] ]; $client->request('POST', 'https://api.procuros.io/v2/transactions', [ 'headers' => $headers, 'json' => $transaction, ]); ``` For a list of all available document types that can be created, as well as the JSON body format for each, please see the [Send Transaction](/en/api/v2/outgoing-transactions/send-transaction) API reference. # Credit Notes Source: https://docs.procuros.io/en/api/v2/receiving-credit-notes This is the right section for you if you are acting as a customer and looking to receive credit notes from your suppliers. In this guide you will learn how to receive new credit notes from the Procuros API, as well as how to paginate over them, mark them as processed, or report any errors with the credit notes. It is important to mark the credit notes as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as errors. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Credit Notes The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Loading Different Document Types **Scenario 1:** You only want to load a specific document type, e.g. `CREDIT_NOTE`. In this case, the easiest way to acheive the filtering is to add the `filter` parameter to the request. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=CREDIT_NOTE', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` **Scenario 2:** You want to load multiple document types, e.g. `CREDIT_NOTE` and `SHIPPING_NOTICE`. In this case, you may want to load all document types and then filter them in your code, preventing multiple round-trip requests the API. You can filter the results by `type` of each returned item to get the documents you need. ```php php theme={null} $transactions = array_filter($items, function($item) { return $item->type === 'SHIPPING_NOTICE' || $item->type === 'CREDIT_NOTE'; }); ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark an Credit Note as Processed To mark an credit note as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'hasBeenProcessed' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Credit Notes as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'hasBeenProcessed' => true ], [ 'procurosTransactionId' => 'def-456', 'hasBeenProcessed' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check if the request was successful ``` ## Report an Error Processing an Credit Note In the event an credit note was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these credit notes as "failed to process". In this case you must set the `hasBeenProcessed` flag to `false`. Additionally you should (but are not required to) add a `reason` for the credit note not being processed, which will be used for solving the issue. ### Single Credit Note ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'hasBeenProcessed' => false, 'reason' => 'Invalid address supplied' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'hasBeenProcessed' => false, 'reason' => 'Invalid address supplied' ], [ 'procurosTransactionId' => 'def-456', 'hasBeenProcessed' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Dispatch Instruction Responses Source: https://docs.procuros.io/en/api/v2/receiving-dispatch-instruction-responses This is the right section for you if you are acting as a supplier and looking to receive dispatch instruction responses from a fulfillment provider. In this guide you will learn how to receive new dispatch instruction responses from the Procuros API, as well as how to paginate over them, mark them as processed, or report any errors with the dispatch instruction responses. It is important to mark the dispatch instruction responses as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as errors. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Dispatch Instruction Responses The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Loading Different Document Types **Scenario 1:** You only want to load a specific document type, e.g. `DISPATCH_INSTRUCTION_RESPONSE`. In this case, the easiest way to acheive the filtering is to add the `filter` parameter to the request. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=DISPATCH_INSTRUCTION_RESPONSE', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` **Scenario 2:** You want to load multiple document types, e.g. `DISPATCH_INSTRUCTION_RESPONSE` and `INVOICE`. In this case, you may want to load all document types and then filter them in your code, preventing multiple round-trip requests the API. You can filter the results by `type` of each returned item to get the documents you need. ```php php theme={null} $transactions = array_filter($items, function($item) { return $item->type === 'INVOICE' || $item->type === 'DISPATCH_INSTRUCTION_RESPONSE'; }); ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark an Dispatch Instruction Response as Processed To mark an dispatch instruction response as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'hasBeenProcessed' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Dispatch Instruction Responses as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'hasBeenProcessed' => true ], [ 'procurosTransactionId' => 'def-456', 'hasBeenProcessed' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check if the request was successful ``` ## Report an Error Processing Dispatch Instruction Response In the event an dispatch instruction response was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these dispatch instruction responses as "failed to process". In this case you must set the `hasBeenProcessed` flag to `false`. Additionally you should (but are not required to) add a `reason` for the dispatch instruction response not being processed, which will be used for solving the issue. ### Single Dispatch Instruction Response ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'hasBeenProcessed' => false, 'reason' => 'Invalid address supplied' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'hasBeenProcessed' => false, 'reason' => 'Invalid address supplied' ], [ 'procurosTransactionId' => 'def-456', 'hasBeenProcessed' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Dispatch Instructions Source: https://docs.procuros.io/en/api/v2/receiving-dispatch-instructions This is the right section for you if you are acting as a fulfillment provider and looking to receive dispatch instructions from suppliers. In this guide you will learn how to receive new dispatch instructions from the Procuros API, as well as how to paginate over them, mark them as processed, or report any errors with the dispatch instructions. It is important to mark the dispatch instructions as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as errors. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Dispatch Instructions The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Loading Different Document Types **Scenario 1:** You only want to load a specific document type, e.g. `DISPATCH_INSTRUCTION`. In this case, the easiest way to acheive the filtering is to add the `filter` parameter to the request. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=DISPATCH_INSTRUCTION', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` **Scenario 2:** You want to load multiple document types, e.g. `DISPATCH_INSTRUCTION` and `INVOICE`. In this case, you may want to load all document types and then filter them in your code, preventing multiple round-trip requests the API. You can filter the results by `type` of each returned item to get the documents you need. ```php php theme={null} $transactions = array_filter($items, function($item) { return $item->type === 'INVOICE' || $item->type === 'DISPATCH_INSTRUCTION'; }); ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark an Dispatch Instruction as Processed To mark an dispatch instruction as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'hasBeenProcessed' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Dispatch Instructions as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'hasBeenProcessed' => true ], [ 'procurosTransactionId' => 'def-456', 'hasBeenProcessed' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check if the request was successful ``` ## Report an Error Processing Dispatch Instruction In the event an dispatch instruction was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these dispatch instructions as "failed to process". In this case you must set the `hasBeenProcessed` flag to `false`. Additionally you should (but are not required to) add a `reason` for the dispatch instruction not being processed, which will be used for solving the issue. ### Single Dispatch Instruction ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'hasBeenProcessed' => false, 'reason' => 'Invalid address supplied' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'hasBeenProcessed' => false, 'reason' => 'Invalid address supplied' ], [ 'procurosTransactionId' => 'def-456', 'hasBeenProcessed' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Invoices Source: https://docs.procuros.io/en/api/v2/receiving-invoices This is the right section for you if you are acting as a customer and looking to receive invoices from your suppliers. In this guide you will learn how to receive new invoices from the Procuros API, as well as how to paginate over them, mark them as processed, or report any errors with the invoices. It is important to mark the invoices as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as errors. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Invoices The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Loading Different Document Types **Scenario 1:** You only want to load a specific document type, e.g. `INVOICE`. In this case, the easiest way to acheive the filtering is to add the `filter` parameter to the request. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=INVOICE', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` **Scenario 2:** You want to load multiple document types, e.g. `INVOICE` and `SHIPPING_NOTICE`. In this case, you may want to load all document types and then filter them in your code, preventing multiple round-trip requests the API. You can filter the results by `type` of each returned item to get the documents you need. ```php php theme={null} $transactions = array_filter($items, function($item) { return $item->type === 'SHIPPING_NOTICE' || $item->type === 'INVOICE'; }); ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark an Invoice as Processed To mark an invoice as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Invoices as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => true ], [ 'procurosTransactionId' => 'def-456', 'success' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check if the request was successful ``` ## Report an Error Processing an Invoice In the event an invoice was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these invoices as "failed to process". In this case you must set the `success` flag to `false`. Additionally you should (but are not required to) add a `reason` for the invoice not being processed, which will be used for solving the issue. ### Single Invoice ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => false, 'reason' => 'Invalid address supplied' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => false, 'reason' => 'Invalid address supplied' ], [ 'procurosTransactionId' => 'def-456', 'success' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Order Responses Source: https://docs.procuros.io/en/api/v2/receiving-order-responses This is the right section for you if you are acting as a customer and looking to receive Order Responses from your suppliers. In this guide you will learn how to receive new Order Responses from the Procuros API, as well as how to paginate over them, mark them as processed, or report any errors with the Order Responses. It is important to mark the Order Responses as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as errors. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). ## Order Response Types Order Responses can have one of three types: * **ACCEPT**: The order was accepted exactly as ordered * **REJECT**: The order was fully rejected * **CHANGE**: Part of the order was accepted but either line item quantities or delivery date are changed Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Order Responses The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Loading Different Document Types **Scenario 1:** You only want to load a specific document type, e.g. `ORDER_RESPONSE`. In this case, the easiest way to achieve the filtering is to add the `filter` parameter to the request. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=ORDER_RESPONSE', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` **Scenario 2:** You want to load multiple document types, e.g. `ORDER_RESPONSE` and `SHIPPING_NOTICE`. In this case, you may want to load all document types and then filter them in your code, preventing multiple round-trip requests the API. You can filter the results by `type` of each returned item to get the documents you need. ```php php theme={null} $transactions = array_filter($items, function($item) { return $item->type === 'SHIPPING_NOTICE' || $item->type === 'ORDER_RESPONSE'; }); ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark an Order Response as Processed To mark an Order Response as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Order Responses as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => true ], [ 'procurosTransactionId' => 'def-456', 'success' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check if the request was successful ``` ## Report an Error Processing an Order Response In the event an Order Response was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these Order Responses as "failed to process". In this case you must set the `success` flag to `false`. Additionally you should (but are not required to) add a `reason` for the Order Response not being processed, which will be used for solving the issue. ### Single Order Response ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => false, 'reason' => 'Unknown order identifier referenced' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => false, 'reason' => 'Unknown order identifier referenced' ], [ 'procurosTransactionId' => 'def-456', 'success' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Orders Source: https://docs.procuros.io/en/api/v2/receiving-orders This is the right section for you if you are acting as a supplier and looking to receive orders from your customers. Throughout this guide you will learn how to pull new orders from the Procuros API, as well as how to paginate over them, mark them as processed, or report errors with the orders. It is important to mark the orders as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as "processing failed".\*\*\*\* PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/incoming-transactions/list-incoming-transactions). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Process Incoming orders retrieved from the Procuros API can be imported into the ERP System. These are usually the steps taken: 1. Uniquely identify customer (see [Trade Partner + Party Identification](/en/api/v2/features-trade-partner-party-identification)) 2. Uniquely identify every product ordered (see [Product Identification](/en/api/v2/features-product-identification)) 3. Handle Bottle Deposits (see [Bottle Deposits](/en/api/v2/features-bottle-deposits)) 4. Resolve customer-specific prices for products (if not done automatically by ERP-System) ### Rules As a general rule of thumb: An order retrieved from Procuros and one manually entered by a user should be exactly the same. One exception could be some way to indicate the “source” of the order being “Procuros” instead of “Manual”, “Shopify”, or something else. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a 2xx status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Orders The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. The Order response includes all header and item level fields, including: * **Header level**: `attachments`, `finalRecipient` party, `technicalRecipient` party, `technicalSender` party, and other party information * **Item level**: `attachments`, product specifications, dimensions, certifications, and other item details Refer to the OpenAPI schema documentation for the complete list of available fields. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=ORDER', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark Orders as Processed To mark an order as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Orders as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => true ], [ 'procurosTransactionId' => 'def-456', 'success' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check the request was successful ``` ## Report an Error Processing Orders In the event an order was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these orders as "failed to process". In this case you must set the `success` flag to `false`. Additionally you should (but are not required to) add a `reason` for the order not being processed, which will be used for solving the issue. ### Single Order ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => false, 'reason' => 'Missing shipping details in order' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => false, 'reason' => 'Missing shipping details in order' ], [ 'procurosTransactionId' => 'def-456', 'success' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Product Catalogs Source: https://docs.procuros.io/en/api/v2/receiving-product-catalogs This is the right section for you if you are acting as a customer and looking to receive Product Catalogs from your suppliers. In this guide you will learn how to receive new Product Catalogs from the Procuros API, as well as how to paginate over them, mark them as processed, or report any errors with the Product Catalogs. It is important to mark the Product Catalogs as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as errors. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Product Catalog The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Loading Different Document Types **Scenario 1:** You only want to load a specific document type, e.g. `PRODUCT_CATALOG`. In this case, the easiest way to achieve the filtering is to add the `filter` parameter to the request. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=PRODUCT_CATALOG', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` **Scenario 2:** You want to load multiple document types, e.g. `PRODUCT_CATALOG` and `SHIPPING_NOTICE`. In this case, you may want to load all document types and then filter them in your code, preventing multiple round-trip requests the API. You can filter the results by `type` of each returned item to get the documents you need. ```php php theme={null} $transactions = array_filter($items, function($item) { return $item->type === 'SHIPPING_NOTICE' || $item->type === 'PRODUCT_CATALOG'; }); ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark an Product Catalog as Processed To mark an Product Catalog as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Product Catalogs as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => true ], [ 'procurosTransactionId' => 'def-456', 'success' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check if the request was successful ``` ## Report an Error Processing a Product Catalog In the event an Product Catalog was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these Product Catalogs as "failed to process". In this case you must set the `success` flag to `false`. Additionally you should (but are not required to) add a `reason` for the Product Catalog not being processed, which will be used for solving the issue. ### Single Product Catalog ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => false, 'reason' => 'Price missing on line item 10' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => false, 'reason' => 'Price missing on line item 10' ], [ 'procurosTransactionId' => 'def-456', 'success' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Sales Reports Source: https://docs.procuros.io/en/api/v2/receiving-sales-report This is the right section for you if you are acting as a supplier and looking to receive sales reports from your buyers. Throughout this guide you will learn how to pull new sales reports from the Procuros API, as well as how to paginate over them, mark them as processed, or report errors with the sales reports. It is important to mark the sales reports as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as "processing failed".\*\*\*\* PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/incoming-transactions/list-incoming-transactions). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a 2xx status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Sales Reports The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=SALES_REPORT', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark Sales Reports as Processed To mark a sales report as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Sales Reports as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => true ], [ 'procurosTransactionId' => 'def-456', 'success' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check the request was successful ``` ## Report an Error Processing Sales Reports In the event a sales report was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these sales reports as "failed to process". In this case you must set the `success` flag to `false`. Additionally you should (but are not required to) add a `reason` for the sales report not being processed, which will be used for solving the issue. ### Single Sales Report ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => false, 'reason' => 'Missing location details in sales report' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => false, 'reason' => 'Missing location details in sales report' ], [ 'procurosTransactionId' => 'def-456', 'success' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Shipping Notices Source: https://docs.procuros.io/en/api/v2/receiving-shipping-notices This is the right section for you if you are acting as a customer and looking to receive shipping notices from your suppliers. In this guide you will learn how to receive new shipping notices from the Procuros API, as well as how to paginate over them, mark them as processed, or report any errors with the shipping notices. It is important to mark the shipping notices as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as errors. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details. ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Pull New Shipping Notices The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions. ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle request('GET', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); $body = json_decode((string) $response->getBody()); $items = $body->items; ``` ### Loading Different Document Types **Scenario 1:** You only want to load a specific document type, e.g. `SHIPPING_NOTICE`. In this case, the easiest way to acheive the filtering is to add the `filter` parameter to the request. ```php php theme={null} $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=SHIPPING_NOTICE', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ``` **Scenario 2:** You want to load multiple document types, e.g. `SHIPPING_NOTICE` and `INVOICE`. In this case, you may want to load all document types and then filter them in your code, preventing multiple round-trip requests the API. You can filter the results by `type` of each returned item to get the documents you need. ```php php theme={null} $transactions = array_filter($items, function($item) { return $item->type === 'SHIPPING_NOTICE' || $item->type === 'INVOICE'; }); ``` ### Pagination The response body has a `hasMore` flag. If it's `true` not all items are in the response. You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again. ```php php theme={null} if ($body->hasMore) { $response = $client->request('GET', $body->nextPageUrl, [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], ]); ... // don't forget to check for errors $body = json_decode((string) $response->getBody()); $items = array_merge($items, $body->items); } ``` If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items. Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description. ## Mark an Shipping Notice as Processed To mark a shipping notice as processed, and take it out of the incoming transactions queue, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed). On the happy path of a transaction being processed successfully, you can make an API call such as: ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => true ] ]); ... // Remember to check the request was successful ``` ### Mark Multiple Shipping Notices as Processed In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint. ```php php theme={null} require_once('vendor/autoload.php'); $client = new \GuzzleHttp\Client(); // You can find the IDs from the original `GET /v2/transactions` call $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => true ], [ 'procurosTransactionId' => 'def-456', 'success' => true ] ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ... // Remember to check if the request was successful ``` ## Report an Error Processing an Shipping Notice In the event a shipping notice was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these shipping notices as "failed to process". In this case you must set the `success` flag to `false`. Additionally you should (but are not required to) add a `reason` for the shipping notice not being processed, which will be used for solving the issue. ### Single Shipping Notice ```php php theme={null} $transaction_id = 'abc-123'; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'success' => false, 'reason' => 'Invalid address supplied' ] ]); ``` ### Bulk Error Reporting ```php php theme={null} $items = [ [ 'procurosTransactionId' => 'abc-123', 'success' => false, 'reason' => 'Invalid address supplied' ], [ 'procurosTransactionId' => 'def-456', 'success' => true ], ]; $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => [ 'items' => $items ] ]); ``` # Order Responses Source: https://docs.procuros.io/en/api/v2/sending-order-responses This is the right section for you if you are acting as a supplier and looking to send Order Responses to your customers in response to their orders. Throughout this guide you will learn how to send Order Responses to the Procuros API. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). ## Order Response Types Order Responses can have one of three types: * **ACCEPT**: Use when the order is accepted exactly as ordered. The `items` array is optional — omit it to confirm all lines as-is, or include it to selectively confirm specific items with adjusted quantities or dates. * **REJECT**: Use when the order is fully rejected. The `items` array must not be included. * **CHANGE**: Use when part of the order is accepted but either line item quantities or delivery date are changed. The `items` array is required and must contain ALL order line items. Omitting `type` (or setting it to `null`) is treated identically to `REJECT` — the `items` array is prohibited and the order is considered fully rejected. Always provide an explicit `type` to avoid unintended rejections. ## Process These are usually the steps taken when sending an Order Response to Procuros: 1. Check, if this document should be sent via Procuros (see: [Enabled Trade Partners](/en/api/v2/features-enabled-trade-partners)) 2. Verify this document has not already been sent (see: [Tracking Document Status](/en/api/v2/features-tracking-document-status)) 3. Build the transaction payload to be sent via Procuros 4. Send the transaction payload via the Procuros API ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Send Order Responses The API call [Send transaction](/en/api/v2/outgoing-transactions/send-transaction) is used to create transactions, including Order Responses. The following fields are required: * `type` (Transaction type. In this case `ORDER_RESPONSE`) * `content` (The details of the Order Response) Inside the `content` you will need to build the Order Response header and optionally items. All details can be found in the `ORDER_RESPONSE` schema as described in the [API reference](/en/api/v2/outgoing-transactions/send-transaction). ### Example: ACCEPT Response Use this when accepting an order exactly as ordered: ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle 'ORDER_RESPONSE', 'content' => [ 'header' => [ 'type' => 'ACCEPT', 'buyer' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '1100001016310'] ] ], 'supplier' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '1100001016312'] ] ], 'orderResponseIdentifier' => 'RE-PO9383-R45', 'orderResponseDate' => '2024-01-15', 'orderIdentifier' => 'PO9383-R45', 'orderDate' => '2024-01-14', 'requestedDeliveryDate' => '2024-01-20', 'confirmedDeliveryDate' => '2024-01-20', 'confirmedShipmentDate' => '2024-01-18', 'currency' => 'EUR' ] ] ]; $response = $client->request('POST', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => $transaction, ]); ``` ### Example: REJECT Response Use this when fully rejecting an order: ```php php theme={null} $transaction = [ 'type' => 'ORDER_RESPONSE', 'content' => [ 'header' => [ 'type' => 'REJECT', 'buyer' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '1100001016310'] ] ], 'supplier' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '1100001016312'] ] ], 'orderResponseIdentifier' => 'RE-PO9383-R45', 'orderResponseDate' => '2024-01-15', 'orderIdentifier' => 'PO9383-R45', 'orderDate' => '2024-01-14', 'currency' => 'EUR', 'comments' => 'Order rejected due to product unavailability' ] ] ]; $response = $client->request('POST', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => $transaction, ]); ``` ### Example: CHANGE Response Use this when partially accepting an order with quantity or delivery date changes. The items array must contain ALL order line items, showing both ordered and confirmed quantities: ```php php theme={null} $transaction = [ 'type' => 'ORDER_RESPONSE', 'content' => [ 'header' => [ 'type' => 'CHANGE', 'buyer' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '1100001016310'] ] ], 'supplier' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '1100001016312'] ] ], 'orderResponseIdentifier' => 'RE-PO9383-R45', 'orderResponseDate' => '2024-01-15', 'orderIdentifier' => 'PO9383-R45', 'orderDate' => '2024-01-14', 'requestedDeliveryDate' => '2024-01-20', 'confirmedDeliveryDate' => '2024-01-22', 'confirmedShipmentDate' => '2024-01-20', 'currency' => 'EUR', 'comments' => 'Partial fulfillment due to limited stock' ], 'items' => [ [ 'lineNumber' => 1, 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '4300348765432'] ], 'isDepositItem' => false, 'orderedQuantity' => 20.0, 'confirmedQuantity' => 15.0, 'unitOfMeasure' => 'EA', 'description' => 'First product description', 'unitPrice' => 0.15, 'pricingUnitOfMeasure' => 'CT', 'pricingUnitQuantity' => 100 ], [ 'lineNumber' => 2, 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '4300348765433'] ], 'isDepositItem' => false, 'orderedQuantity' => 19.0, 'confirmedQuantity' => 19.0, 'unitOfMeasure' => 'EA', 'description' => 'Second product description', 'unitPrice' => 1.50, 'pricingUnitOfMeasure' => 'CT' 'pricingUnitQuantity' => 100, ] ] ] ]; $response = $client->request('POST', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => $transaction, ]); ``` When using the `CHANGE` type, the `items` array must contain ALL order line items, regardless of whether `orderedQuantity` and `confirmedQuantity` are equal. This allows the buyer to see the complete picture of what will be delivered. ## Mark Document Status Finally, as per the instructions mentioned under [Tracking Document Status](/en/api/v2/features-tracking-document-status) you must now track the status of the document locally, based on the returned HTTP response. The document should be marked with either status `TRANSMITTED` or `NO_ACTION`. If there is an error with the document and it is not accepted, do not mark it with a status so it may be retried. For more information on retrying failed documents, please see: [Retrying Documents](/en/api/v2/features-tracking-document-status#retrying-documents). For example: ```php php theme={null} $statusCode = $response->getStatusCode(); if ($statusCode == 201) { $document->updateProcurosStatus("TRANSMITTED"); } else if ($statusCode == 202) { $document->updateProcurosStatus("NO_ACTION"); } else { // No need to do anything if it's not accepted, in an error case the document should be retried. } ``` # Orders Source: https://docs.procuros.io/en/api/v2/sending-orders This is the right section for you if you are acting as a customer and looking to send orders to your suppliers. Throughout this guide you will learn how to send new orders to the Procuros API. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). ## Process These are usually the steps taken when sending an order to Procuros: 1. Check, if this document should be sent via Procuros (see: [Enabled Trade Partners](/en/api/v2/features-enabled-trade-partners)) 2. Verify this document has not already been sent (see: [Tracking Document Status](/en/api/v2/features-tracking-document-status)) 3. Build the transaction payload to be sent via Procuros 4. Send the transaction payload via the Procuros API ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Send Orders The API call [Send transaction](/en/api/v2/outgoing-transactions/send-transaction) is used to create transactions, including orders. The following fields are required: * `type` (Transaction type. In this case `ORDER`) * `content` (The details of the order items.) Inside the `content` you will need to build all order items. All details can be found in the `ORDER` schema as described in the [API reference](/en/api/v2/outgoing-transactions/send-transaction). The example below shows commonly used fields. The Order schema supports many additional optional fields including: * **Header level**: `deliveryInformation`, `purchasingInformation`, `legalInformation`, `attachments`, `finalRecipient` party, `technicalRecipient` party, `technicalSender` party * **Item level**: `size`, `dimension`, `hsCode`, `cnCode`, `colorCode`, `colorName`, `fscNumber`, `deliveryGracePeriodInDays`, `certificationsRequired`, `attachments` **Date format**: All date fields (e.g. `orderDate`, `requestedDeliveryDate`) must use ISO 8601 format: `YYYY-MM-DD` (e.g. `2023-12-06`). For the complete list of available fields, refer to the OpenAPI schema documentation. An example request would look like: ```php php theme={null} // install dependency // $ composer require guzzlehttp/guzzle 'ORDER', 'content' => [ 'header' => [ 'orderIdentifier' => 'bestellung-20231203-012', 'orderDate' => '2023-12-03', 'currency' => 'EUR', 'requestedDeliveryDate' => '2023-12-06', 'type' => 'STANDARD', 'comments' => 'Please deliver to loading dock 3', 'contractReference' => 'CONTRACT-2023-ABC', 'buyer' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '3220010000010'] ] ], 'supplier' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '3220010000003'] ] ], 'billTo' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '3220010000010'] ] ], 'shipTo' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '3220010000011'] ] ], 'technicalRecipient' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '3220010000010'] ] ], 'technicalSender' => [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '3220010000012'] ] ], 'AdditionalOrderIdentifiers' => [ 'supplierOrderIdentifier' => 'SUP-ORDER-789', 'shipToOrderIdentifier' => 'SHIP-REF-456' ], 'paymentTerms' => [ [ 'payInNumberOfDays' => 30, 'percentage' => 5 ] ] ], 'items' => [ [ 'identifiers' => [ ['domain' => 'GS1', 'identifier' => '2330000000083'] ], 'lineNumber' => 1, 'quantity' => 10, 'isDepositItem' => false, 'unitOfMeasure' => 'EA', 'description' => 'Premium Organic Coffee Beans 1kg', 'comments' => 'Please handle with care - fragile packaging', 'requestedDeliveryDate' => null, 'requestedEarliestDeliveryDate' => '2023-12-05', 'requestedLatestDeliveryDate' => '2023-12-08', 'minimumRemainingShelfLifeInDays' => 90, 'unitPrice' => 1.23, 'pricingUnitOfMeasure' => 'CT', 'pricingUnitQuantity' => 100, 'recommendedRetailPrice' => 1.85, 'netWeight' => 1000, 'grossWeight' => 1050, 'originCountryCode' => 'BR', 'tax' => [ 'percentage' => 7, 'description' => 'Umsatzsteuer' ], 'brand' => 'kela', 'assortment' => 'ME_GEN', 'consumerGroup' => 'Unisex', 'category' => '1008', 'subCategory' => 'Beverages', 'organicControlPointNumber' => 'DE-ÖKO-006', 'certificationsRequired' => [ 'fairtrade' => true, 'supplierQa' => false, 'eudr' => true ], 'contractReference' => 'ITEM-CONTRACT-XYZ', 'promotionCode' => 'WINTER2023', 'attachments' => [ [ 'fileName' => 'technical_datasheet.pdf', 'url' => 'https://example.com/attachments/technical_datasheet.pdf', 'mimeType' => 'application/pdf', 'type' => 'TECHNICAL_DATASHEET' ], [ 'fileName' => 'product_label.pdf', 'url' => 'https://example.com/attachments/product_label.pdf', 'mimeType' => 'application/pdf', 'type' => 'PRODUCT_LABEL' ] ], 'modificationGroups' => [ [ 'basis' => 12.30, 'level' => 1, 'modifications' => [ [ 'type' => 'ALLOWANCE', 'calculationType' => 'RELATIVE', 'reasonCode' => 'DISCOUNT', 'description' => 'Contract trade discount', 'percentage' => 7 ] ] ] ] ] ] ] ]; $response = $client->request('POST', 'https://api.procuros.io/v2/transactions', [ 'headers' => [ 'Accept' => 'application/json', 'Authorization' => 'Bearer ', ], 'json' => $transaction, ]); ``` ## Mark Document Status Finally, as per the instructions mentioned under [Tracking Document Status](/en/api/v2/features-tracking-document-status) you must now track the status of the document locally, based on the returned HTTP response. The document should be marked with either status `TRANSMITTED` or `NO_ACTION`. If there is an error with the document and it is not accepted, do not mark it with a status so it may be retried. For more information on retrying failed documents, please see: [Retrying Documents](/en/api/v2/features-tracking-document-status#retrying-documents). For example: ```php php theme={null} $statusCode = $response->getStatusCode(); $responseBody = json_decode($response->getBody()->getContents(), true); if ($statusCode == 201) { $document->updateProcurosStatus("TRANSMITTED"); $document->updateProcurosTransactionId($responseBody['procurosTransactionId']); } else if ($statusCode == 202) { $document->updateProcurosStatus("NO_ACTION"); $document->updateProcurosTransactionId($responseBody['procurosTransactionId']); } else { // No need to do anything if it's not accepted, in an error case the document should be retried. } ``` # Product Catalogs Source: https://docs.procuros.io/en/api/v2/sending-product-catalogs This is the right section for you if you are acting as a supplier and looking to send product catalogs to your customers. Throughout this guide you will learn how to send product catalogs to the Procuros API. PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/overview). ## Process These are usually the steps taken when sending an product catalog to Procuros: 1. Check, if this document should be sent via Procuros (see: [Enabled Trade Partners](/en/api/v2/features-enabled-trade-partners)) 2. Verify this document has not already been sent (see: [Tracking Document Status](/en/api/v2/features-tracking-document-status)) 3. Build the transaction payload to be sent via Procuros. 4. Send the transaction payload via the Procuros API ## Authentication You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API. Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description. ## Error Handling The API will return a `2xx` status code for successful requests. Anything else indicates an error. Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them. ## Send product catalogs The API call [Send transaction](/en/api/v2/outgoing-transactions/send-transaction) is used to create transactions, including product catalogs. The following fields are required: * `type` (Transaction type. In this case `PRODUCT_CATALOG`) * `content` (The details of the product catalogs
[...]
